Index: /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5202)
@@ -299,5 +311,5 @@
   !--- PARSE "type_trac" LIST AND DETERMINE THE TRACERS FILES NAMES (FOR CASE 3: MULTIPLE FILES, SINGLE SECTION PER FILE)
   !--- If type_trac is a scalar (case 1), "sections" and "trac_files" are not usable, but are meaningless for case 1 anyway.
-  IF(test(strParse(type_trac, '|', sections,  n=nsec), lerr)) RETURN !--- Parse "type_trac" list
+  lerr = strParse(type_trac, '|', sections, n=nsec); IF(lerr) RETURN !--- Parse "type_trac" list
   IF(PRESENT(sects)) sects = sections
   ALLOCATE(trac_files(nsec), ll(nsec))
@@ -313,5 +325,5 @@
   IF(.NOT.lD) RETURN                                                 !--- NO CHECKING/DISPLAY NEEDED: JUST GET type_trac,fType
   IF(ANY(ll) .AND. fType/=3) THEN                                    !--- MISSING FILES
-    IF(test(checkList(trac_files, .NOT.ll, 'Failed reading tracers description', 'files', 'missing'), lerr)) RETURN
+    lerr = checkList(trac_files, .NOT.ll, 'Failed reading tracers description', 'files', 'missing'); IF(lerr) RETURN
   END IF
 
@@ -344,6 +356,6 @@
   ll = strCount(snames, '|', ndb)                                    !--- Number of sections for each file
   ALLOCATE(ixf(SUM(ndb)))
-  DO i=1, SIZE(fnames)                                               !--- Set %name, %keys
-    IF(test(readSections(fnames(i), snames(i), 'default'), lerr)) RETURN
+  DO i=1, SIZE(fnames)                                               !--- Set name, keys
+    lerr = readSections(fnames(i), snames(i), 'default'); IF(lerr) RETURN
     ixf(1+SUM(ndb(1:i-1)):SUM(ndb(1:i))) = i                         !--- File index for each section of the expanded list
   END DO
@@ -353,10 +365,10 @@
     fnm = fnames(ixf(idb)); snm = dBase(idb)%name                    !--- FILE AND SECTION NAMES
     lerr = ANY([(dispTraSection('RAW CONTENT OF SECTION "'//TRIM(snm)//'"', snm, modname), idb=1, SIZE(dBase))])
-    IF(test(expandSection(dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- EXPAND NAMES ;  set %parent, %type, %component
-    IF(test(setGeneration(dBase(idb)%trac),           lerr)) RETURN  !---                 set %iGeneration,   %genOName
-    IF(test(checkTracers (dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- CHECK ORPHANS AND PHASES
-    IF(test(checkUnique  (dBase(idb)%trac, snm, fnm), lerr)) RETURN  !--- CHECK TRACERS UNIQUENESS
-    CALL expandPhases    (dBase(idb)%trac)                           !--- EXPAND PHASES ; set %phase
-    CALL sortTracers     (dBase(idb)%trac)                           !--- SORT TRACERS
+    lerr = expandSection(dBase(idb)%trac, snm, fnm); IF(lerr) RETURN !--- EXPAND NAMES ;  SET parent, type, component
+    lerr = setGeneration(dBase(idb)%trac);           IF(lerr) RETURN !---                 SET iGeneration,  genOName
+    lerr = checkTracers (dBase(idb)%trac, snm, fnm); IF(lerr) RETURN !--- CHECK ORPHANS AND PHASES
+    lerr = checkUnique  (dBase(idb)%trac, snm, fnm); IF(lerr) RETURN !--- CHECK TRACERS UNIQUENESS
+    lerr = expandPhases (dBase(idb)%trac);           IF(lerr) RETURN !--- EXPAND PHASES ; set phase
+    CALL sortTracers    (dBase(idb)%trac)                            !--- SORT TRACERS
     lerr = ANY([(dispTraSection('EXPANDED CONTENT OF SECTION "'//TRIM(snm)//'"', snm, modname), idb=1, SIZE(dBase))])
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -387,5 +399,5 @@
   ll = strParse(snam, '|', keys = sec)                               !--- Requested sections names
   ix = strIdx(dBase(:)%name, sec(:))                                 !--- Indexes of requested sections in database
-  IF(test(checkList(sec, ix == 0, 'In file "'//TRIM(fnam)//'"','section(s)', 'missing'), lerr)) RETURN
+  lerr = checkList(sec, ix == 0, 'In file "'//TRIM(fnam)//'"','section(s)', 'missing'); IF(lerr) RETURN
   tdb = dBase(:); dBase = [tdb(1:n0-1),tdb(PACK(ix, MASK=ix/=0))]    !--- Keep requested sections only
 
@@ -403,5 +415,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   IF(.NOT.ALLOCATED(dBase)) ALLOCATE(dBase(0))
-  OPEN(90, FILE=fnam, FORM='formatted', STATUS='old')
+  OPEN(90, FILE=fnam, FORM='formatted', POSITION='REWIND', STATUS='old')
   DO; str=''
     DO
@@ -416,4 +428,5 @@
     IF(str(1:1)=='#') CYCLE                                          !--- Skip comments lines
     CALL removeComment(str)                                          !--- Skip comments at the end of a line
+    IF(LEN_TRIM(str) == 0) CYCLE                                     !--- Empty line (probably end of file)
     IF(str     == '') CYCLE                                          !--- Skip empty line (probably at the end of the file)
     IF(str(1:1)=='&') THEN                                           !=== SECTION HEADER LINE
@@ -431,8 +444,8 @@
       ll = strParse(str,' ', s, n, v)                                !--- Parse <key>=<val> pairs
       tt = dBase(ndb)%trac(:)
-      tmp%name = s(1); tmp%keys = keys_type(s(1), s(2:n), v(2:n))    !--- Set %name and %keys
+      v(1) = s(1); s(1) = 'name'                                     !--- Convert "name" into a regular key
+      tmp%name = v(1); tmp%keys = keys_type(v(1), s(:), v(:))        !--- Set %name and %keys
       dBase(ndb)%trac = [tt(:), tmp]
-      DEALLOCATE(tt)
-!      dBase(ndb)%trac = [dBase(ndb)%trac(:), tra(name=s(1), keys=keys_type(s(1), s(2:n), v(2:n)))]
+      DEALLOCATE(tt, tmp%keys%key, tmp%keys%val)
     END IF
   END DO
@@ -460,6 +473,6 @@
   ky => t(jd)%keys
   DO k = 1, SIZE(ky%key)                                             !--- Loop on the keys of the tracer named "defName"
-!   CALL addKey_m(ky%key(k), ky%val(k), t(:)%keys, .FALSE.)           !--- Add key to all the tracers (no overwriting)
-    DO it = 1, SIZE(t); CALL addKey_1(ky%key(k), ky%val(k), t(it)%keys, .FALSE.); END DO
+!   CALL addKey(ky%key(k), ky%val(k), t(:)%keys, .FALSE.)            !--- Add key to all the tracers (no overwriting)
+    DO it = 1, SIZE(t); CALL addKey(ky%key(k), ky%val(k), t(it)%keys, .FALSE.); END DO
   END DO
   tt = [t(1:jd-1),t(jd+1:SIZE(t))]; CALL MOVE_ALLOC(FROM=tt, TO=t)   !--- Remove the virtual tracer named "defName"
@@ -506,8 +519,8 @@
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)                 !--- Tracer derived type vector
-  CHARACTER(LEN=*),             INTENT(IN)    :: sname
-  CHARACTER(LEN=*), OPTIONAL,   INTENT(IN)    :: fname
+  CHARACTER(LEN=*),             INTENT(IN)    :: sname                 !--- Current section name
+  CHARACTER(LEN=*), OPTIONAL,   INTENT(IN)    :: fname                 !--- Tracers description file name
   TYPE(trac_type),       ALLOCATABLE :: ttr(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: ta(:), pa(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: ta(:), pa(:), tname(:), parent(:), dType(:)
   CHARACTER(LEN=maxlen) :: msg1, modname
   INTEGER :: it, nt, iq, nq, itr, ntr, ipr, npr
@@ -516,4 +529,7 @@
   lerr = .FALSE.
   nt = SIZE(tr)
+  lerr = getKey('name',   tname,  tr(:)%keys);                 IF(lerr) RETURN
+  lerr = getKey('parent', parent, tr(:)%keys, def = tran0);    IF(lerr) RETURN
+  lerr = getKey('type',   dType,  tr(:)%keys, def = 'tracer'); IF(lerr) RETURN
   nq = 0
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -521,19 +537,17 @@
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     !--- Extract useful keys: parent name, type, component name
-    tr(it)%parent    = fgetKey(it, 'parent', tr(:)%keys,  tran0  )
-    tr(it)%type      = fgetKey(it, 'type'  , tr(:)%keys, 'tracer')
     tr(it)%component = sname
-!   CALL addKey_m('component', sname, tr(:)%keys)
-    DO iq=1,SIZE(tr); CALL addKey_1('component', sname, tr(iq)%keys); END DO
+    CALL addKey('component', sname,  tr(it)%keys)
 
     !--- Determine the number of tracers and parents ; coherence checking
-    ll = strCount(tr(it)%name,   ',', ntr)
-    ll = strCount(tr(it)%parent, ',', npr)
+    ll = strCount( tname(it), ',', ntr)
+    ll = strCount(parent(it), ',', npr)
 
     !--- Tagging tracers only can have multiple parents
-    IF(test(npr/=1 .AND. TRIM(tr(it)%type)/='tag', lerr)) THEN
+    lerr = npr /=1 .AND. TRIM(dType(it)) /= 'tag'
+    IF(lerr) THEN
       msg1 = 'Check section "'//TRIM(sname)//'"'
-      IF(PRESENT(fname)) msg1=TRIM(msg1)//' in file "'//TRIM(fname)//'"'
-      CALL msg(TRIM(msg1)//': "'//TRIM(tr(it)%name)//'" has several parents but is not a tag', modname); RETURN
+      IF(PRESENT(fname)) msg1 = TRIM(msg1)//' in file "'//TRIM(fname)//'"'
+      CALL msg(TRIM(msg1)//': "'//TRIM(tname(it))//'" has several parents but is not a tag', modname); RETURN
     END IF
     nq = nq + ntr*npr                 
@@ -547,16 +561,20 @@
   DO it = 1, nt                                                      !=== EXPAND TRACERS AND PARENTS NAMES LISTS
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-    ll = strParse(tr(it)%name,   ',', ta, ntr)                       !--- Number of tracers
-    ll = strParse(tr(it)%parent, ',', pa, npr)                       !--- Number of parents
-    DO ipr=1,npr                                                     !--- Loop on parents list elts
-      DO itr=1,ntr                                                   !--- Loop on tracers list elts
+    ll = strParse( tname(it), ',', ta, ntr)                          !--- Number of tracers
+    ll = strParse(parent(it), ',', pa, npr)                          !--- Number of parents
+    DO ipr = 1, npr                                                  !--- Loop on parents list elts
+      DO itr = 1, ntr                                                !--- Loop on tracers list elts
+        ttr(iq)%keys%name = TRIM(ta(itr))
         ttr(iq)%keys%key  = tr(it)%keys%key
         ttr(iq)%keys%val  = tr(it)%keys%val
-        ttr(iq)%keys%name = ta(itr)
-        ttr(iq)%name      = TRIM(ta(itr));    CALL addKey_1('name',      ta(itr),          ttr(iq)%keys)
-        ttr(iq)%parent    = TRIM(pa(ipr));    CALL addKey_1('parent',    pa(ipr),          ttr(iq)%keys)
-        ttr(iq)%type      = tr(it)%type;      CALL addKey_1('type',      tr(it)%type,      ttr(iq)%keys)
-        ttr(iq)%component = tr(it)%component; CALL addKey_1('component', tr(it)%component, ttr(iq)%keys)
-        iq = iq+1
+        ttr(iq)%name      = TRIM(ta(itr))
+        ttr(iq)%parent    = TRIM(pa(ipr))
+        ttr(iq)%type      = dType(it)
+        ttr(iq)%component = sname
+        CALL addKey('name',      ta(itr),   ttr(iq)%keys)
+        CALL addKey('parent',    pa(ipr),   ttr(iq)%keys)
+        CALL addKey('type',      dType(it), ttr(iq)%keys)
+        CALL addKey('component', sname,     ttr(iq)%keys)
+        iq = iq + 1
       END DO
     END DO
@@ -575,24 +593,28 @@
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Determine, for each tracer of "tr(:)":
-!   * %iGeneration: the generation number 
-!   * %gen0Name:    the generation 0 ancestor name
-!          Check also for orphan tracers (tracers not descending on "tran0").
+!   * iGeneration: the generation number 
+!   * gen0Name:    the generation 0 ancestor name
+!          Check also for orphan tracers (tracers without parent).
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE(trac_type),     INTENT(INOUT) :: tr(:)                        !--- Tracer derived type vector
   INTEGER                            :: iq, jq, ig
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: parent(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: parent(:), tname(:)
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: modname
   modname = 'setGeneration'
-  IF(test(fmsg('missing "parent" attribute', modname, getKey('parent', parent, ky=tr(:)%keys)), lerr)) RETURN
+  lerr = getKey('name',   tname,  ky=tr(:)%keys); IF(lerr) RETURN
+  lerr = getKey('parent', parent, ky=tr(:)%keys); IF(lerr) RETURN
   DO iq = 1, SIZE(tr)
     jq = iq; ig = 0
     DO WHILE(parent(jq) /= tran0)
-      jq = strIdx(tr(:)%name, parent(jq))
-      IF(test(fmsg('Orphan tracer "'//TRIM(tr(iq)%name)//'"', modname, jq == 0), lerr)) RETURN
+      jq = strIdx(tname(:), parent(jq))
+      lerr = jq == 0
+      IF(fmsg('Orphan tracer "'//TRIM(tname(iq))//'"', modname, lerr)) RETURN
       ig = ig + 1
     END DO
-    tr(iq)%gen0Name = tr(jq)%name; CALL addKey_1('gen0Name',    tr(iq)%gen0Name,   tr(iq)%keys)
-    tr(iq)%iGeneration = ig;       CALL addKey_1('iGeneration', TRIM(int2str(ig)), tr(iq)%keys)
+    tr(iq)%gen0Name = tname(jq)
+    tr(iq)%iGeneration = ig
+    CALL addKey('iGeneration',   ig,  tr(iq)%keys)
+    CALL addKey('gen0Name', tname(jq), tr(iq)%keys)
   END DO
 END FUNCTION setGeneration
@@ -604,30 +626,36 @@
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose:
-!   * check for orphan tracers (without known parent)
-!   * check wether the phases are known or not ("g"aseous, "l"iquid or "s"olid so far)
+!   * check for orphan tracers (without parent)
+!   * check wether the phases are known or not (elements of "known_phases")
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fname                    !--- File name
+  CHARACTER(LEN=1) :: p
   CHARACTER(LEN=maxlen) :: mesg
   CHARACTER(LEN=maxlen) :: bp(SIZE(tr, DIM=1)), pha                  !--- Bad phases list, phases of current tracer
-  CHARACTER(LEN=1) :: p
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
+  INTEGER,               ALLOCATABLE ::  iGen(:)
   INTEGER :: ip, np, iq, nq
 !------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: modname
+  modname = 'checkTracers'
   nq = SIZE(tr,DIM=1)                                                !--- Number of tracers lines
   mesg = 'Check section "'//TRIM(sname)//'"'
   IF(PRESENT(fname)) mesg=TRIM(mesg)//' in file "'//TRIM(fname)//'"'
+  lerr = getKey('iGeneration', iGen, tr(:)%keys);               IF(lerr) RETURN
+  lerr = getKey('name',       tname, tr(:)%keys);               IF(lerr) RETURN
 
   !=== CHECK FOR ORPHAN TRACERS
-  IF(test(checkList(tr%name, tr%iGeneration==-1, mesg, 'tracers', 'orphan'), lerr)) RETURN
+  lerr = checkList(tname, iGen==-1, mesg, 'tracers', 'orphan'); IF(lerr) RETURN
 
   !=== CHECK PHASES
-  DO iq=1,nq; IF(tr(iq)%iGeneration/=0) CYCLE                        !--- Generation O only is checked
-    pha = fgetKey(iq, 'phases', tr(:)%keys, 'g')                     !--- Phases
+  DO iq = 1, nq; IF(iGen(iq) /= 0) CYCLE                             !--- Generation O only is checked
+    IF(getKey(['phases','phase '], pha, iq, tr(:)%keys, lDisp=.FALSE.)) pha = 'g'   !--- Phase
     np = LEN_TRIM(pha); bp(iq)=' '
-    DO ip=1,np; p = pha(ip:ip); IF(INDEX(known_phases,p)==0) bp(iq) = TRIM(bp(iq))//p; END DO
-    IF(TRIM(bp(iq)) /= '') bp(iq) = TRIM(tr(iq)%name)//': '//TRIM(bp(iq))
+    DO ip = 1, np; p = pha(ip:ip); IF(INDEX(known_phases, p) == 0) bp(iq) = TRIM(bp(iq))//p; END DO
+    IF(TRIM(bp(iq)) /= '') bp(iq) = TRIM(tname(iq))//': '//TRIM(bp(iq))
   END DO
-  lerr = checkList(bp, tr%iGeneration==0 .AND. bp/='', mesg, 'tracers phases', 'unknown')
+  lerr = checkList(bp, iGen == 0 .AND. bp /= '', mesg, 'tracers phases', 'unknown')
 END FUNCTION checkTracers
 !==============================================================================================================================
@@ -645,27 +673,38 @@
   INTEGER :: ip, np, iq, nq, k
   LOGICAL, ALLOCATABLE  :: ll(:)
-  CHARACTER(LEN=maxlen) :: mesg, tnam, tdup(SIZE(tr,DIM=1))
-  CHARACTER(LEN=1)      :: p
-!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: mesg, phase, tdup(SIZE(tr,DIM=1))
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), dType(:)
+  INTEGER,               ALLOCATABLE :: iGen(:)
+  CHARACTER(LEN=1) :: p
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: modname
+  modname = 'checkUnique'
   mesg = 'Check section "'//TRIM(sname)//'"'
   IF(PRESENT(fname)) mesg=TRIM(mesg)//' in file "'//TRIM(fname)//'"'
   nq=SIZE(tr,DIM=1); lerr=.FALSE.                                    !--- Number of lines ; error flag
   tdup(:) = ''
-  DO iq=1,nq; IF(tr(iq)%type == 'tag') CYCLE                         !--- Tags can be repeated
-    tnam = TRIM(tr(iq)%name)
-    ll = tr(:)%name==TRIM(tnam)                                      !--- Mask for current tracer name
-    IF(COUNT(ll)==1 ) CYCLE                                          !--- Tracer is not repeated
-    IF(tr(iq)%iGeneration>0) THEN
-      tdup(iq) = tnam                                                !--- gen>0: MUST be unique
+  lerr = getKey('name',       tname, tr%keys); IF(lerr) RETURN
+  lerr = getKey('type',       dType, tr%keys); IF(lerr) RETURN
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN
+  DO iq = 1, nq
+    IF(dType(iq) == 'tag') CYCLE                                     !--- Tags can be repeated
+    ll = tname==TRIM(tname(iq))                                      !--- Mask for current tracer name
+    IF(COUNT(ll) == 1) CYCLE                                         !--- Tracer is not repeated
+    IF(iGen(iq) > 0) THEN
+      tdup(iq) = tname(iq)                                           !--- gen>0: MUST be unique
     ELSE
-      DO ip=1,nphases; p=known_phases(ip:ip)                         !--- Loop on known phases
-        !--- Number of appearances of the current tracer with known phase "p"
-        np = COUNT( PACK( [(INDEX(fgetKey(k, 'phases', tr(:)%keys, 'g'),p), k=1, nq)] /=0 , MASK=ll ) )
-        IF(np <=1) CYCLE
-        tdup(iq) = TRIM(tdup(iq))//TRIM(phases_names(ip))
+      DO ip = 1, nphases; p = known_phases(ip:ip)                    !--- Loop on known phases
+        np = 0
+        DO k = 1, nq
+          IF(.NOT.ll(k)) CYCLE                                       !--- Skip tracers different from current one
+          IF(getKey(['phases','phase '], phase, k, tr%keys, lDisp=.FALSE.)) phase='g'!--- Get current phases
+          IF(INDEX(phase, p) /= 0) np = np + 1                       !--- One more appearance of current tracer with phase "p"
+        END DO
+        IF(np <= 1) CYCLE                                            !--- Regular case: no or a single appearance
+        tdup(iq) = TRIM(tdup(iq))//TRIM(phases_names(ip))            !--- Repeated phase
         IF(ANY(tdup(1:iq-1) == tdup(iq))) tdup(iq)=''                !--- Avoid repeating same messages
       END DO
     END IF
-    IF(tdup(iq) /= '') tdup(iq)=TRIM(tnam)//' in '//TRIM(tdup(iq))//' phase(s)'
+    IF(tdup(iq) /= '') tdup(iq)=TRIM(tname(iq))//' in '//TRIM(tdup(iq))//' phase(s)'
   END DO
   lerr = checkList(tdup, tdup/='', mesg, 'tracers', 'duplicated')
@@ -675,5 +714,5 @@
 
 !==============================================================================================================================
-SUBROUTINE expandPhases(tr)
+LOGICAL FUNCTION expandPhases(tr) RESULT(lerr)
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Expand the phases in the tracers descriptor "tr". Phases are not repeated for a tracer, thanks to "checkUnique".
@@ -681,18 +720,26 @@
   TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracer derived type vector
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(trac_type), ALLOCATABLE :: ttr(:)
-  INTEGER,   ALLOCATABLE ::  i0(:)
-  CHARACTER(LEN=maxlen)  :: nam, pha, tname
+  TYPE(trac_type),       ALLOCATABLE :: ttr(:)
+  INTEGER,               ALLOCATABLE ::  i0(:), iGen(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), gen0N(:), phase(:), parents(:), dType(:)
+  CHARACTER(LEN=maxlen)              ::  nam,     gen0Nm,   pha,      parent
   CHARACTER(LEN=1) :: p
   INTEGER :: ip, np, iq, jq, nq, it, nt, nc, i, n
   LOGICAL :: lTag, lExt
 !------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: modname
+  modname = 'expandPhases'
   nq = SIZE(tr, DIM=1)
   nt = 0
+  lerr = getKey('name',       tname, tr%keys); IF(lerr) RETURN       !--- Names of the tracers
+  lerr = getKey('gen0Name',   gen0N, tr%keys); IF(lerr) RETURN       !--- Names of the tracers of first generation
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN       !--- Generation number
+  lerr = getKey('phases',     phase, tr%keys); IF(lerr) RETURN       !--- Phases names
+  lerr = getKey('parent',   parents, tr%keys); IF(lerr) RETURN       !--- Parents names
+  lerr = getKey('type',       dType, tr%keys); IF(lerr) RETURN       !--- Tracers types ('tracer' or 'tag')
   DO iq = 1, nq                                                      !--- GET THE NUMBER OF TRACERS
-    IF(tr(iq)%iGeneration /= 0) CYCLE                                !--- Only deal with generation 0 tracers
-    nc = COUNT(tr(:)%gen0Name==tr(iq)%name .AND. tr%iGeneration/=0)  !--- Number of children of tr(iq)
-    tr(iq)%phase = fgetKey(iq, 'phases', tr(:)%keys)                 !--- Phases list        of tr(iq)
-    np = LEN_TRIM(tr(iq)%phase)                                      !--- Number of phases   of tr(iq)
+    IF(iGen(iq) /= 0) CYCLE                                          !--- Only deal with generation 0 tracers
+    nc = COUNT(gen0N == tname(iq) .AND. iGen /= 0)                   !--- Number of children of tr(iq)
+    np = LEN_TRIM(phase(iq))                                         !--- Number of phases   of tr(iq)
     nt = nt + (1+nc) * np                                            !--- Number of tracers after expansion
   END DO
@@ -700,34 +747,36 @@
   it = 1                                                             !--- Current "ttr(:)" index
   DO iq = 1, nq                                                      !--- Loop on "tr(:)" indexes
-    lTag = tr(iq)%type=='tag'                                        !--- Current tracer is a tag
-    i0 = strFind(tr(:)%name, TRIM(tr(iq)%gen0Name), n)               !--- Indexes of first generation ancestor copies
-    np = SUM([( LEN_TRIM(tr(i0(i))%phase),i=1,n )], 1)               !--- Number of phases for current tracer tr(iq)
-    lExt = np>1                                                      !--- Phase suffix only required if phases number is > 1
-    IF(lTag) lExt = lExt .AND. tr(iq)%iGeneration>0                  !--- No phase suffix for generation 0 tags
-    DO i=1,n                                                         !=== LOOP ON GENERATION 0 ANCESTORS
+    lTag = dType(iq)=='tag'                                          !--- Current tracer is a tag
+    i0 = strFind(tname, TRIM(gen0N(iq)), n)                          !--- Indexes of first generation ancestor copies
+    np = SUM([( LEN_TRIM(phase(i0(i))), i = 1, n )], 1)              !--- Number of phases for current tracer tr(iq)
+    lExt = np > 1                                                    !--- Phase suffix only required if phases number is > 1
+    IF(lTag) lExt = lExt .AND. iGen(iq) > 0                          !--- No phase suffix for generation 0 tags
+    DO i = 1, n                                                      !=== LOOP ON GENERATION 0 ANCESTORS
       jq = i0(i)                                                     !--- tr(jq): ith tracer with same gen 0 ancestor as tr(iq)
-      IF(tr(iq)%iGeneration==0) jq=iq                                !--- Generation 0: count the current tracer phases only
-      pha = tr(jq)%phase                                             !--- Phases list for tr(jq)
+      IF(iGen(iq) == 0) jq = iq                                      !--- Generation 0: count the current tracer phases only
+      pha = phase(jq)                                                !--- Phases list for tr(jq)
       DO ip = 1, LEN_TRIM(pha)                                       !=== LOOP ON PHASES LISTS
         p = pha(ip:ip)
-        tname = TRIM(tr(iq)%name); nam = tname                       !--- Tracer name (regular case)
-        IF(lTag) nam = TRIM(tr(iq)%parent)                           !--- Parent name (tagging case)
+        nam = tname(iq)                                              !--- Tracer name (regular case)
+        IF(lTag) nam = TRIM(parents(iq))                             !--- Parent name (tagging case)
         IF(lExt) nam = addPhase(nam, p )                             !--- Phase extension needed
-        IF(lTag) nam = TRIM(nam)//'_'//TRIM(tname)                   !--- <parent>_<name> for tags
+        IF(lTag) nam = TRIM(nam)//'_'//TRIM(tname(iq))               !--- <parent>_<name> for tags
         ttr(it) = tr(iq)                                             !--- Same <key>=<val> pairs
         ttr(it)%name      = TRIM(nam)                                !--- Name with possibly phase suffix
         ttr(it)%keys%name = TRIM(nam)                                !--- Name inside the keys decriptor
         ttr(it)%phase     = p                                        !--- Single phase entry
-        CALL addKey_1('name', nam, ttr(it)%keys)
-        CALL addKey_1('phase', p,  ttr(it)%keys)
-        IF(lExt .AND. tr(iq)%iGeneration>0) THEN
-          ttr(it)%parent   = addPhase(tr(iq)%parent,   p)
-          ttr(it)%gen0Name = addPhase(tr(iq)%gen0Name, p)
-          CALL addKey_1('parent',   ttr(it)%parent,   ttr(it)%keys)
-          CALL addKey_1('gen0Name', ttr(it)%gen0Name, ttr(it)%keys)
+        CALL addKey('name', nam, ttr(it)%keys)
+        CALL addKey('phase', p,  ttr(it)%keys)
+        IF(lExt) THEN
+          parent = parents(iq); IF(iGen(iq) > 0) parent = addPhase(parent, p)
+          gen0Nm =   gen0N(iq); IF(iGen(iq) > 0) gen0Nm = addPhase(gen0Nm, p)
+          ttr(it)%parent   = parent
+          ttr(it)%gen0Name = gen0Nm
+          CALL addKey('parent',   parent, ttr(it)%keys)
+          CALL addKey('gen0Name', gen0Nm, ttr(it)%keys)
         END IF
         it = it+1
       END DO
-      IF(tr(iq)%iGeneration==0) EXIT                                 !--- Break phase loop for gen 0
+      IF(iGen(iq) == 0) EXIT                                         !--- Break phase loop for gen 0
     END DO
   END DO
@@ -735,5 +784,5 @@
   CALL delKey(['phases'],tr)                                         !--- Remove few keys entries
 
-END SUBROUTINE expandPhases
+END FUNCTION expandPhases
 !==============================================================================================================================
 
@@ -748,14 +797,19 @@
 !   TO BE ADDED IF NECESSARY: HIGHER MOMENTS AT THE END
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)         !--- Tracer derived type vector
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE(trac_type), ALLOCATABLE        :: tr2(:)
-  INTEGER,         ALLOCATABLE        :: iy(:), iz(:)
-  INTEGER                             :: ig, ng, iq, jq, ip, nq, n, ix(SIZE(tr)), k
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)                            !--- Tracer derived type vector
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE(trac_type),       ALLOCATABLE :: tr2(:)
+  INTEGER,               ALLOCATABLE :: iy(:), iz(:)
+  INTEGER,               ALLOCATABLE ::  iGen(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), gen0N(:)
+  INTEGER :: ig, ng, iq, jq, ip, nq, n, ix(SIZE(tr)), k
+  LOGICAL :: lerr
 !  tr2 is introduced in order to cope with a bug in gfortran 4.8.5 compiler
 !------------------------------------------------------------------------------------------------------------------------------
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN       !--- Generation number
   nq = SIZE(tr)
   DO ip = nphases, 1, -1
-    iq = strIdx(tr(:)%name, addPhase('H2O', ip))
+    lerr = getKey('name',     tname, tr%keys); IF(lerr) RETURN       !--- Names of the tracers of first generation
+    iq = strIdx(tname, addPhase('H2O', ip))
     IF(iq == 0) CYCLE
     tr2 = tr(:)
@@ -764,7 +818,7 @@
   IF(lSortByGen) THEN
     iq = 1
-    ng = MAXVAL(tr(:)%iGeneration, MASK=.TRUE., DIM=1)               !--- Number of generations
+    ng = MAXVAL(iGen, MASK=.TRUE., DIM=1)                            !--- Number of generations
     DO ig = 0, ng                                                    !--- Loop on generations
-      iy = PACK([(k, k=1, nq)], MASK=tr(:)%iGeneration==ig)          !--- Generation ig tracers indexes
+      iy = PACK([(k, k=1, nq)], MASK=iGen(:) == ig)                  !--- Generation ig tracers indexes
       n = SIZE(iy)
       ix(iq:iq+n-1) = iy                                             !--- Stack growing generations idxs
